Index: /trunk/NEMO/OPA_SRC/DIA/diaptr.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DIA/diaptr.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DIA/diaptr.F90	(revision 392)
@@ -88,5 +88,5 @@
       !! * local declarations
       INTEGER  ::   ji, jj, jk        ! dummy loop arguments
-#if ! defined key_AGRIF
+#if ! defined key_agrif
       INTEGER  ::   ijpj = jpj        ! ???
 #else
@@ -96,5 +96,5 @@
          p_fval                       ! function value
       !!--------------------------------------------------------------------
-#if defined key_AGRIF
+#if defined key_agrif
       ijpj = jpj
 #endif      
@@ -136,5 +136,5 @@
       !! * local declarations
       INTEGER  ::   ji,jj             ! dummy loop arguments
-#if ! defined key_AGRIF
+#if ! defined key_agrif
       INTEGER  ::   ijpj = jpj        ! ???
 #else
@@ -144,5 +144,5 @@
          p_fval                       ! function value
       !!--------------------------------------------------------------------
-#if defined key_AGRIF
+#if defined key_agrif
       ijpj = jpj
 #endif      
Index: /trunk/NEMO/OPA_SRC/DOM/dom_oce.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 392)
@@ -197,5 +197,5 @@
       !                        ! parameterize exchanges through straits
 
-#if defined key_AGRIF
+#if defined key_agrif
    !!----------------------------------------------------------------------
    !! agrif sponge layer
Index: /trunk/NEMO/OPA_SRC/DOM/domain.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DOM/domain.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DOM/domain.F90	(revision 392)
@@ -264,5 +264,5 @@
       ENDIF
 
-#if defined key_AGRIF
+#if defined key_agrif
       if ( Agrif_Root() ) then
 #endif
@@ -278,5 +278,5 @@
          IF(lwp) WRITE(numout,*) '           The IOIPSL calendar is "360d", i.e. 360 days in a year'
       END SELECT
-#if defined key_AGRIF
+#if defined key_agrif
       endif
 #endif
Index: /trunk/NEMO/OPA_SRC/DOM/domhgr.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DOM/domhgr.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DOM/domhgr.F90	(revision 392)
@@ -236,5 +236,5 @@
          gphi0 = - ppe2_m * 1.e-3
          
-#if defined key_AGRIF && defined key_eel_r6
+#if defined key_agrif && defined key_eel_r6
          IF (.Not.Agrif_Root()) THEN
            glam0  = Agrif_Parent(glam0) + (Agrif_ix())*Agrif_Parent(ppe1_m) * 1.e-3
@@ -434,5 +434,5 @@
          zphi0   = ppgphi0 - FLOAT( jpjglo/2) * ppe2_m / ( ra * rad )           ! latitude of the first row F-points
          
-#if defined key_AGRIF && defined key_eel_r6
+#if defined key_agrif && defined key_eel_r6
          IF (.Not.Agrif_Root()) THEN
            zphi0 = ppgphi0 - FLOAT( Agrif_Parent(jpjglo)/2)*Agrif_Parent(ppe2_m) / (ra * rad)
@@ -513,5 +513,5 @@
       !!----------------------------------------------------------------------
       clname = 'coordinates'
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
Index: /trunk/NEMO/OPA_SRC/DOM/domwri.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DOM/domwri.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DOM/domwri.F90	(revision 392)
@@ -104,5 +104,5 @@
          clnam4 = 'mesh_zgr'   ! filename (vertical   mesh informations)
 
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
         clnam0 = TRIM(Agrif_CFixed())//'_'//TRIM(clnam0)
Index: /trunk/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 392)
@@ -391,5 +391,5 @@
 
          clname = 'bathy_level.nc'                       ! Level bathymetry
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
@@ -420,5 +420,5 @@
 
          clname = 'bathy_meter.nc'                       ! meter bathymetry
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
Index: /trunk/NEMO/OPA_SRC/DTA/dtasal.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DTA/dtasal.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DTA/dtasal.F90	(revision 392)
@@ -121,5 +121,5 @@
          
          clname = 'data_1m_salinity_nomask'
-#if defined key_AGRIF
+#if defined key_agrif
          if ( .NOT. Agrif_Root() ) then
             clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
Index: /trunk/NEMO/OPA_SRC/DTA/dtasst.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DTA/dtasst.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DTA/dtasst.F90	(revision 392)
@@ -94,5 +94,5 @@
       !!----------------------------------------------------------------------
          clname = 'sst_1d.nc'
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
Index: /trunk/NEMO/OPA_SRC/DTA/dtatem.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DTA/dtatem.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DTA/dtatem.F90	(revision 392)
@@ -100,5 +100,5 @@
       cl_tdata = 'data_1m_potential_temperature_nomask '
 
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          cl_tdata = TRIM(Agrif_CFixed())//'_'//TRIM(cl_tdata)
Index: /trunk/NEMO/OPA_SRC/DYN/divcur.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DYN/divcur.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DYN/divcur.F90	(revision 392)
@@ -130,5 +130,5 @@
          IF( lp_obc_south )   hdivn(nis0  :nis1  ,njs0  :njs1  ,jk) = 0.e0      ! south
 #endif         
-#if defined key_AGRIF
+#if defined key_agrif
          if ( .NOT. AGRIF_Root() ) then
             IF ((nbondi ==  1).OR.(nbondi == 2)) hdivn(nlci-1 , :     ,jk) = 0.e0      ! east
@@ -334,5 +334,5 @@
          IF( lp_obc_south )   hdivn(nis0  :nis1  ,njs0  :njs1  ,jk) = 0.e0      ! south
 #endif         
-#if defined key_AGRIF
+#if defined key_agrif
          if ( .NOT. AGRIF_Root() ) then
             IF ((nbondi ==  1).OR.(nbondi == 2)) hdivn(nlci-1 , :     ,jk) = 0.e0      ! east
Index: /trunk/NEMO/OPA_SRC/DYN/dynnxt.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 392)
@@ -135,5 +135,5 @@
          !                                             ! ===============
 # endif
-# if defined key_AGRIF
+# if defined key_agrif
          !                                             ! ===============
       END DO                                           !   End of slab
@@ -178,5 +178,5 @@
       ENDIF
 
-#if defined key_AGRIF
+#if defined key_agrif
       IF (.NOT.Agrif_Root())    CALL Agrif_Update_Dyn( kt )
 #endif      
Index: /trunk/NEMO/OPA_SRC/DYN/dynspg_flt.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DYN/dynspg_flt.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DYN/dynspg_flt.F90	(revision 392)
@@ -171,5 +171,5 @@
       CALL obc_vol( kt )
 #endif
-#if defined key_AGRIF
+#if defined key_agrif
       ! Update velocities on each coarse/fine interfaces
 
@@ -239,5 +239,5 @@
       IF( nsolv == 4 )   CALL lbc_lnk_e( gcb, c_solver_pt, 1. )   
 
-#if defined key_AGRIF
+#if defined key_agrif
 
        If (.NOT.AGRIF_ROOT()) THEN
@@ -315,5 +315,5 @@
       END DO
 
-#if defined key_AGRIF      
+#if defined key_agrif      
       IF (.NOT. Agrif_Root()) THEN
       ! caution : grad D (fine) = grad D (coarse) at coarse/fine interface
Index: /trunk/NEMO/OPA_SRC/DYN/dynspg_flt_jki.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DYN/dynspg_flt_jki.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/DYN/dynspg_flt_jki.F90	(revision 392)
@@ -37,4 +37,5 @@
    USE prtctl          ! Print control
    USE in_out_manager  ! I/O manager
+   USE agrif_opa_interp
 
    IMPLICIT NONE
@@ -178,4 +179,10 @@
          CALL obc_vol( kt )
 #endif
+#if defined key_agrif
+      ! Update velocities on each coarse/fine interfaces
+
+      CALL Agrif_dyn( kt )
+
+#endif
 #if defined key_orca_r2
       IF( n_cla == 1 )   CALL dyn_spg_cla( kt )      ! Cross Land Advection (Update (ua,va))
@@ -237,4 +244,22 @@
       ! applied the lateral boundary conditions
       IF( nsolv == 4)   CALL lbc_lnk_e( gcb, c_solver_pt, 1. )  
+
+#if defined key_agrif
+
+       If (.NOT.AGRIF_ROOT()) THEN
+
+         ! add contribution of gradient of after barotropic transport divergence 
+        IF ((nbondi == -1).OR.(nbondi == 2)) gcb(3,:) = gcb(3,:) &
+                        -znugdt * z2dt*laplacu(2,:)*gcdprc(3,:)*hu(2,:)*e2u(2,:)
+        IF ((nbondi == 1).OR.(nbondi == 2))  gcb(nlci-2,:) = gcb(nlci-2,:) &
+                       +znugdt * z2dt*laplacu(nlci-2,:)*gcdprc(nlci-2,:)*hu(nlci-2,:)*e2u(nlci-2,:)
+        IF ((nbondj == -1).OR.(nbondj == 2)) gcb(:,3) = gcb(:,3) &
+                       -znugdt * z2dt*laplacv(:,2)*gcdprc(:,3)*hv(:,2)*e1v(:,2)
+        IF ((nbondj == 1).OR.(nbondj == 2))  gcb(:,nlcj-2) = gcb(:,nlcj-2) &
+                       +znugdt * z2dt*laplacv(:,nlcj-2)*gcdprc(:,nlcj-2)*hv(:,nlcj-2)*e1v(:,nlcj-2)
+
+       ENDIF
+
+#endif
 
       !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,synchro,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
@@ -310,4 +335,14 @@
          END DO
          
+#if defined key_agrif      
+      IF (.NOT. Agrif_Root()) THEN
+      ! caution : grad D (fine) = grad D (coarse) at coarse/fine interface
+        IF ((nbondi == -1).OR.(nbondi == 2)) spgu(2,:) = znugdt * z2dt * laplacu(2,:) * umask(2,:,1)
+        IF ((nbondi == 1).OR.(nbondi == 2)) spgu(nlci-2,:) = znugdt * z2dt * laplacu(nlci-2,:) * umask(nlci-2,:,1)
+        IF ((nbondj == -1).OR.(nbondj == 2)) spgv(:,2) = znugdt * z2dt * laplacv(:,2) * vmask(:,2,1)
+        IF ((nbondj == 1).OR.(nbondj == 2)) spgv(:,nlcj-2) = znugdt * z2dt * laplacv(:,nlcj-2) * vmask(:,nlcj-2,1)
+      ENDIF
+#endif
+      
          ! 7.  Add the trends multiplied by z2dt to the after velocity
          ! -----------------------------------------------------------
Index: /trunk/NEMO/OPA_SRC/SBC/flx_bulk_monthly.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/SBC/flx_bulk_monthly.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/SBC/flx_bulk_monthly.h90	(revision 392)
@@ -132,5 +132,5 @@
 
          ! title, dimensions and tests
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
Index: /trunk/NEMO/OPA_SRC/SBC/flx_forced_daily.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/SBC/flx_forced_daily.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/SBC/flx_forced_daily.h90	(revision 392)
@@ -123,5 +123,5 @@
          IF(lwp) WRITE (numout,*) iy
          WRITE(clname,'("flx_1d.nc")') 
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
Index: /trunk/NEMO/OPA_SRC/SBC/tau_forced_daily.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/SBC/tau_forced_daily.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/SBC/tau_forced_daily.h90	(revision 392)
@@ -93,5 +93,5 @@
          ENDIF
          ! title, dimensions and tests
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          cl_taux = TRIM(Agrif_CFixed())//'_'//TRIM(cl_taux)
@@ -117,5 +117,5 @@
             nstop = nstop + 1
          ENDIF
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          cl_tauy = TRIM(Agrif_CFixed())//'_'//TRIM(cl_tauy)
Index: /trunk/NEMO/OPA_SRC/SBC/tau_forced_monthly.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/SBC/tau_forced_monthly.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/SBC/tau_forced_monthly.h90	(revision 392)
@@ -109,5 +109,5 @@
          ! title, dimensions and tests
 
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          cl_taux = TRIM(Agrif_CFixed())//'_'//TRIM(cl_taux)
@@ -134,5 +134,5 @@
             nstop = nstop + 1
          ENDIF
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          cl_tauy = TRIM(Agrif_CFixed())//'_'//TRIM(cl_tauy)
Index: /trunk/NEMO/OPA_SRC/SOL/sol_oce.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/SOL/sol_oce.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/SOL/sol_oce.F90	(revision 392)
@@ -67,5 +67,5 @@
       gccd             !: vector such that ca.gccd=a.d (ca-1=gcdprc)
 
-#if defined key_AGRIF
+#if defined key_agrif
       REAL(wp), DIMENSION(jpi,jpj) :: laplacu, laplacv
 #endif
Index: /trunk/NEMO/OPA_SRC/SOL/solmat.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/SOL/solmat.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/SOL/solmat.F90	(revision 392)
@@ -183,5 +183,5 @@
 !!cr  ENDIF
 #endif
-#if defined key_AGRIF
+#if defined key_agrif
        IF (.NOT.AGRIF_ROOT()) THEN
        
Index: /trunk/NEMO/OPA_SRC/TRA/trabbc.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/TRA/trabbc.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/TRA/trabbc.F90	(revision 392)
@@ -189,5 +189,5 @@
          ! read the geothermal fluxes in mW/m2
          clname = 'geothermal_heating'
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
Index: /trunk/NEMO/OPA_SRC/TRA/tradmp.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 392)
@@ -36,5 +36,5 @@
    !! * Shared module variables
    LOGICAL , PUBLIC &
-#if ! defined key_AGRIF
+#if ! defined key_agrif
    , PARAMETER  &
 #endif
Index: /trunk/NEMO/OPA_SRC/TRA/tranxt.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 392)
@@ -110,5 +110,5 @@
          !                                             ! ===============
 #endif
-#if defined key_AGRIF
+#if defined key_agrif
          !                                             ! ===============
       END DO                                           !   End of slab
@@ -185,5 +185,5 @@
       ENDIF
       
-#if defined key_AGRIF
+#if defined key_agrif
       IF (.NOT.Agrif_Root())    CALL Agrif_Update_Tra( kt )
 #endif      
Index: /trunk/NEMO/OPA_SRC/ctlopn.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/ctlopn.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/ctlopn.F90	(revision 392)
@@ -12,5 +12,5 @@
       !!   8.5  !  02-06  (G. Madec)  F90: Free form and module
       !!----------------------------------------------------------------------
-#if defined key_AGRIF
+#if defined key_agrif
       USE Agrif_Util
 #endif
@@ -18,5 +18,5 @@
 
       INTEGER, INTENT( in ) ::   &
-#if !defined key_AGRIF
+#if !defined key_agrif
          knum,     & ! logical unit to open
 #endif
@@ -31,5 +31,5 @@
          cdform,   & ! formatting specifier
          cdstat      ! disposition specifier
-#if !defined key_AGRIF
+#if !defined key_agrif
       CHARACTER (len=* ), INTENT( in ) ::   &
          cdfile      ! file name to open
@@ -38,5 +38,5 @@
       LOGICAL ::  ldwp   ! boolean term for print
 
-#if defined key_AGRIF
+#if defined key_agrif
       LOGICAL :: op
       INTEGER, INTENT( inout ) ::   &
@@ -51,5 +51,5 @@
       !!----------------------------------------------------------------------
 
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          cdfile= TRIM(Agrif_CFixed())//'_'//TRIM(cdfile)
Index: /trunk/NEMO/OPA_SRC/istate.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/istate.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/istate.F90	(revision 392)
@@ -330,5 +330,5 @@
             itime  = 0
             clname = 'eel.initemp'
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
Index: /trunk/NEMO/OPA_SRC/lib_mpp.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/lib_mpp.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/lib_mpp.F90	(revision 392)
@@ -288,18 +288,18 @@
       CASE ( 'S' )                ! Standard mpi send (blocking)
          WRITE(numout,*) '           Standard blocking mpi send (send)'
-#if defined key_AGRIF
+#if defined key_agrif
          IF ( Agrif_Root() ) THEN
 #endif      
          CALL mpi_init( ierr )
-#if defined key_AGRIF
+#if defined key_agrif
          ENDIF
 #endif	 
       CASE ( 'B' )                ! Buffer mpi send (blocking)
          WRITE(numout,*) '           Buffer blocking mpi send (bsend)'
-#if defined key_AGRIF
+#if defined key_agrif
          IF ( Agrif_Root() ) THEN
 #endif      
          CALL mpi_init_opa( ierr )
-#if defined key_AGRIF
+#if defined key_agrif
          ENDIF
 #endif	 
@@ -307,9 +307,9 @@
          WRITE(numout,*) '           Immediate non-blocking send (isend)'
          l_isend = .TRUE.
-#if defined key_AGRIF
+#if defined key_agrif
          IF ( Agrif_Root() ) THEN
 #endif      
          CALL mpi_init( ierr )
-#if defined key_AGRIF
+#if defined key_agrif
          ENDIF
 #endif	 
Index: /trunk/NEMO/OPA_SRC/mppini_2.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/mppini_2.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/mppini_2.h90	(revision 392)
@@ -122,5 +122,5 @@
             clvar = 'Bathy_level'
          ENDIF
-#if defined key_AGRIF
+#if defined key_agrif
       if ( .NOT. Agrif_Root() ) then
          clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
Index: /trunk/NEMO/OPA_SRC/opa.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/opa.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/opa.F90	(revision 392)
@@ -110,5 +110,5 @@
       !!----------------------------------------------------------------------
 
-#if defined key_AGRIF
+#if defined key_agrif
 
       Call Agrif_Init_Grids()
@@ -120,5 +120,5 @@
          istp = nit000
          DO WHILE ( istp <= nitend .AND. nstop == 0 )
-#if defined key_AGRIF
+#if defined key_agrif
             CALL Agrif_Step(stp_1d)
 #else
@@ -130,5 +130,5 @@
          istp = nit000
          DO WHILE ( istp <= nitend .AND. nstop == 0 )
-#if defined key_AGRIF
+#if defined key_agrif
             CALL Agrif_Step(stp)
 #else
Index: /trunk/NEMO/OPA_SRC/par_EEL_R2.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/par_EEL_R2.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/par_EEL_R2.h90	(revision 392)
@@ -9,5 +9,5 @@
    !!----------------------------------------------------------------------
    CHARACTER (len=16)      &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -15,5 +15,5 @@
       cp_cfg = "eel"            !: name of the configuration
    INTEGER     &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
Index: /trunk/NEMO/OPA_SRC/par_EEL_R5.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/par_EEL_R5.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/par_EEL_R5.h90	(revision 392)
@@ -9,10 +9,10 @@
    !!----------------------------------------------------------------------
    CHARACTER (len=16)      &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
       ::    &  
    INTEGER     &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
Index: /trunk/NEMO/OPA_SRC/par_EEL_R6.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/par_EEL_R6.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/par_EEL_R6.h90	(revision 392)
@@ -9,5 +9,5 @@
    !!----------------------------------------------------------------------
    CHARACTER (len=16)      &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -15,5 +15,5 @@
       cp_cfg = "eel"            !: name of the configuration
    INTEGER     &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -62,5 +62,5 @@
       !   of the constraint that the equator be a T point.
    REAL(wp) &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
Index: /trunk/NEMO/OPA_SRC/par_GYRE.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/par_GYRE.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/par_GYRE.h90	(revision 392)
@@ -9,5 +9,5 @@
    !!----------------------------------------------------------------------
    CHARACTER (len=16)      &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -15,5 +15,5 @@
       cp_cfg = "gyre"           !: name of the configuration
    INTEGER     &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
Index: /trunk/NEMO/OPA_SRC/par_ORCA_R025.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/par_ORCA_R025.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/par_ORCA_R025.h90	(revision 392)
@@ -10,5 +10,5 @@
    !!----------------------------------------------------------------------
    CHARACTER (len=16)      &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -16,5 +16,5 @@
       cp_cfg = "orca"           !: name of the configuration
    INTEGER     &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
Index: /trunk/NEMO/OPA_SRC/par_ORCA_R05.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/par_ORCA_R05.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/par_ORCA_R05.h90	(revision 392)
@@ -10,5 +10,5 @@
    !!----------------------------------------------------------------------
    CHARACTER (len=16)      &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -16,5 +16,5 @@
       cp_cfg = "orca"           !: name of the configuration
    INTEGER     &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -30,5 +30,5 @@
       ! zoom domain size       !!! *  antarctic zoom  * 
    INTEGER     &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -48,5 +48,5 @@
       ! zoom domain size       !!! *  arctic zoom  *
    INTEGER    &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -67,5 +67,5 @@
       ! global domain size     !!! *  global domain  *
    INTEGER    &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
Index: /trunk/NEMO/OPA_SRC/par_ORCA_R2.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/par_ORCA_R2.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/par_ORCA_R2.h90	(revision 392)
@@ -10,5 +10,5 @@
    !!----------------------------------------------------------------------
    CHARACTER (len=16)      &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -16,5 +16,5 @@
       cp_cfg = "orca"           !: name of the configuration 
    INTEGER     &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -30,5 +30,5 @@
       ! zoom domain size       !!! *  antarctic zoom  * 
    INTEGER     &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -48,5 +48,5 @@
       ! zoom domain size       !!! *  arctic zoom  *
    INTEGER    &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -66,5 +66,5 @@
       ! global domain size     !!! *  global domain  *
    INTEGER    &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -95,5 +95,5 @@
       ! global domain size     !!! *  global domain  *
    INTEGER    &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
Index: /trunk/NEMO/OPA_SRC/par_ORCA_R4.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/par_ORCA_R4.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/par_ORCA_R4.h90	(revision 392)
@@ -10,5 +10,5 @@
    !!----------------------------------------------------------------------
    CHARACTER (len=16)      &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
@@ -16,5 +16,5 @@
      cp_cfg = "orca"           !: name of the configuration
    INTEGER     &
-#if !defined key_AGRIF
+#if !defined key_agrif
       , PARAMETER  &
 #endif
Index: /trunk/NEMO/OPA_SRC/par_oce.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/par_oce.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/par_oce.F90	(revision 392)
@@ -169,5 +169,5 @@
    !!---------------------------------------------------------------------
    INTEGER  &  !:
-#if !defined key_AGRIF
+#if !defined key_agrif
       ,PARAMETER  &
 #endif
@@ -180,5 +180,5 @@
       jpij  = jpi*jpj                                               !:  jpi x jpj
 
-#if defined key_AGRIF
+#if defined key_agrif
    !!---------------------------------------------------------------------
    !! Agrif variables
Index: /trunk/NEMO/OPA_SRC/restart.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/restart.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/restart.F90	(revision 392)
@@ -88,5 +88,5 @@
       REAL(wp), DIMENSION(10) ::   zinfo(10)
       REAL(wp), DIMENSION(jpi,jpj) :: ztab 
-#if defined key_AGRIF
+#if defined key_agrif
        Integer :: knum
 #endif
@@ -127,5 +127,5 @@
          INQUIRE( FILE=crestart, EXIST=llbon )
          IF(llbon) THEN
-#if defined key_AGRIF
+#if defined key_agrif
        knum =Agrif_Get_Unit()
             OPEN( UNIT=knum, FILE=crestart, STATUS='old' )
@@ -275,5 +275,5 @@
       !!----------------------------------------------------------------------
       clname = 'restart'
-#if defined key_AGRIF       
+#if defined key_agrif       
        inum = Agrif_Get_Unit()
        If(.NOT. Agrif_root() ) clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
Index: /trunk/NEMO/OPA_SRC/restart_dimg.h90
===================================================================
--- /trunk/NEMO/OPA_SRC/restart_dimg.h90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/restart_dimg.h90	(revision 392)
@@ -62,5 +62,5 @@
        irecl8= jpi * jpj * wp
        WRITE(clres,'(a,i3.3)') 'restart.output.',narea
-#if defined key_AGRIF 
+#if defined key_agrif 
        inum = Agrif_Get_Unit()      
        If(.NOT. Agrif_root() ) clres = TRIM(Agrif_CFixed())//'_'//TRIM(clres)
@@ -273,5 +273,5 @@
     ! Open direct access file, with reclength for 2D wp fields
     WRITE(clres,'(a,i3.3)') 'restart.',narea
-#if defined key_AGRIF       
+#if defined key_agrif       
     inum = Agrif_Get_Unit()
     If(.NOT. Agrif_root() ) clres = TRIM(Agrif_CFixed())//'_'//TRIM(clres)
Index: /trunk/NEMO/OPA_SRC/step.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/step.F90	(revision 391)
+++ /trunk/NEMO/OPA_SRC/step.F90	(revision 392)
@@ -118,5 +118,5 @@
    USE prtctl          ! Print control                    (prt_ctl routine)
 
-#if defined key_AGRIF
+#if defined key_agrif
    USE agrif_opa_sponge ! Momemtum and tracers sponges
 #endif
@@ -140,5 +140,5 @@
 
    SUBROUTINE stp( &
-#if !defined key_AGRIF
+#if !defined key_agrif
    kstp &
 #endif   
@@ -175,5 +175,5 @@
       !! * Arguments
       INTEGER &
-#if !defined key_AGRIF   
+#if !defined key_agrif   
       , INTENT( in ) &
 #endif      
@@ -184,5 +184,5 @@
       !! ---------------------------------------------------------------------
 
-#if defined key_AGRIF
+#if defined key_agrif
       kstp = nit000 + Agrif_Nb_Step()
       IF ( Agrif_Root() .and. lwp) Write(*,*) '---'
@@ -336,5 +336,5 @@
       IF( l_traldf_iso_zps )   CALL tra_ldf_iso_zps( kstp )           ! partial step iso-neutral/geopot. laplacian
 
-#if defined key_AGRIF
+#if defined key_agrif
       IF (.NOT. Agrif_Root())  CALL Agrif_Sponge_tra( kstp )          ! tracers sponge
 #endif
@@ -386,5 +386,5 @@
       IF( l_dynldf_iso     )   CALL dyn_ldf_iso    ( kstp )          ! iso-neutral laplacian 
 
-#if defined key_AGRIF
+#if defined key_agrif
       IF (.NOT. Agrif_Root())  CALL Agrif_Sponge_dyn( kstp )         ! momemtum sponge
 #endif