Index: /trunk/CONFIG/GYRE/scripts/BB_make
===================================================================
--- /trunk/CONFIG/GYRE/scripts/BB_make	(revision 400)
+++ /trunk/CONFIG/GYRE/scripts/BB_make	(revision 401)
@@ -383,5 +383,8 @@
 #-Q- aix		-qsource \
 	   OPAFILES/$*.F90 || { mv $(PREF).L $(TMP) ; false ; exit ; }
-		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null 
+#-Q- sxnec		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
+#-Q- sx6nec		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
+#-Q- sxdkrz		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
+#-Q- hpux			@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
 endif
 
@@ -437,4 +440,9 @@
 		@$(P_C) $(P_O) -IOPAFILES/AGRIF_INC $*.F90 > OPAFILES/$*.F90 
 		@(cd OPAFILES ; ./conv agrif_opa.in -rm \
+#-Q- linux		-SubloopScalar \
+#-Q- lxiv8		-SubloopScalar \
+#-Q- g95			-SubloopScalar \
+#-Q- f95			-SubloopScalar \
+#-Q- osf1			-SubloopScalar \
 		-comdirin ./ -comdirout AGRIF_MODELFILES/. -convfile $*.F90)
 		-@mv -f OPAFILES/AGRIF_MODELFILES/$*.F90 OPAFILES/$*.F90
@@ -948,5 +956,5 @@
 	cpl_oce.F90
 \
-	\() $(MODEL_LIB)(daymod.o) :	\
+	$() $(MODEL_LIB)(daymod.o) :	\
 	dom_oce.F90 \
 	in_out_manager.F90 \
@@ -2370,5 +2378,5 @@
 	$(MODEL_LIB)(oce.o) \
 	$(MODEL_LIB)(prtctl.o) \
-	\() \
+	$() \
 	dynnxt.F90
 $(MODEL_LIB)(dynspg.o) :	\
@@ -2760,5 +2768,5 @@
 	domzgr_substitute.h90 \
 	vectopt_loop_substitute.h90 \
-	\() \
+	$() \
 	KEY_CPP \
 	dynspg_flt.F90
@@ -2875,5 +2883,5 @@
 	$(MODEL_LIB)(zdf_oce.o) \
 	domzgr_substitute.h90 \
-	\() \
+	$() \
 	KEY_CPP \
 	dynspg_flt_jki.F90
@@ -7337,5 +7345,5 @@
 	domzgr_substitute.h90 \
 	zdfddm_substitute.h90 \
-	\() \
+	$() \
 	KEY_CPP \
 	step.F90
@@ -8331,5 +8339,5 @@
 	$(MODEL_LIB)(prtctl.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
-	\() \
+	$() \
 	tranxt.F90
 $(MODEL_LIB)(traqsr.o) :	\
Index: /trunk/CONFIG/GYRE/scripts/BB_make.ldef
===================================================================
--- /trunk/CONFIG/GYRE/scripts/BB_make.ldef	(revision 400)
+++ /trunk/CONFIG/GYRE/scripts/BB_make.ldef	(revision 401)
@@ -37,8 +37,8 @@
 #-
 #- Prefix for preprocessing ---
-#-Q- sxnec  prefix = -Wp,-D
-#-Q- sx6nec prefix = -Wp,-D
-#-Q- eshpux prefix = -Wp,-D
-#-Q- sxdkrz prefix = -Wp,-D
+#-Q- sxnec  prefix = -D
+#-Q- sx6nec prefix = -D
+#-Q- eshpux prefix = -D
+#-Q- sxdkrz prefix = -D
 #-Q- linux  prefix = -D
 #-Q- lxiv7  prefix = -D
Index: /trunk/CONFIG/ORCA2_LIM/scripts/BB_make
===================================================================
--- /trunk/CONFIG/ORCA2_LIM/scripts/BB_make	(revision 400)
+++ /trunk/CONFIG/ORCA2_LIM/scripts/BB_make	(revision 401)
@@ -384,5 +384,8 @@
 #-Q- aix		-qsource \
 	   OPAFILES/$*.F90 || { mv $(PREF).L $(TMP) ; false ; exit ; }
-		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null 
+#-Q- sxnec		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
+#-Q- sx6nec		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
+#-Q- sxdkrz		@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
+#-Q- hpux			@$(A_X) $(SXMODEL_LIB) $*.o  > /dev/null
 endif
 
@@ -438,4 +441,9 @@
 		@$(P_C) $(P_O) -IOPAFILES/AGRIF_INC $*.F90 > OPAFILES/$*.F90 
 		@(cd OPAFILES ; ./conv agrif_opa.in -rm \
+#-Q- linux		-SubloopScalar \
+#-Q- lxiv8		-SubloopScalar \
+#-Q- g95			-SubloopScalar \
+#-Q- f95			-SubloopScalar \
+#-Q- osf1			-SubloopScalar \
 		-comdirin ./ -comdirout AGRIF_MODELFILES/. -convfile $*.F90)
 		-@mv -f OPAFILES/AGRIF_MODELFILES/$*.F90 OPAFILES/$*.F90
@@ -715,5 +723,5 @@
 	$(MODEL_LIB)(sol_oce.o) \
 	$(MODEL_LIB)(tradmp.o) \
-	\() \
+	$() \
 	agrif_user.F90
 $(MODEL_LIB)(albedo.o) :	\
@@ -1151,5 +1159,5 @@
 	cpl_oce.F90
 \
-	\() $(MODEL_LIB)(daymod.o) :	\
+	$() $(MODEL_LIB)(daymod.o) :	\
 	dom_oce.F90 \
 	in_out_manager.F90 \
@@ -2583,5 +2591,5 @@
 	$(MODEL_LIB)(oce.o) \
 	$(MODEL_LIB)(prtctl.o) \
-	\() \
+	$() \
 	dynnxt.F90
 $(MODEL_LIB)(dynspg.o) :	\
@@ -2973,5 +2981,5 @@
 	domzgr_substitute.h90 \
 	vectopt_loop_substitute.h90 \
-	\() \
+	$() \
 	KEY_CPP \
 	dynspg_flt.F90
@@ -3088,5 +3096,5 @@
 	$(MODEL_LIB)(zdf_oce.o) \
 	domzgr_substitute.h90 \
-	\() \
+	$() \
 	KEY_CPP \
 	dynspg_flt_jki.F90
@@ -7550,5 +7558,5 @@
 	domzgr_substitute.h90 \
 	zdfddm_substitute.h90 \
-	\() \
+	$() \
 	KEY_CPP \
 	step.F90
@@ -8554,5 +8562,5 @@
 	$(MODEL_LIB)(prtctl.o) \
 	$(MODEL_LIB)(zdf_oce.o) \
-	\() \
+	$() \
 	tranxt.F90
 $(MODEL_LIB)(traqsr.o) :	\
Index: /trunk/CONFIG/ORCA2_LIM/scripts/BB_make.ldef
===================================================================
--- /trunk/CONFIG/ORCA2_LIM/scripts/BB_make.ldef	(revision 400)
+++ /trunk/CONFIG/ORCA2_LIM/scripts/BB_make.ldef	(revision 401)
@@ -37,8 +37,8 @@
 #-
 #- Prefix for preprocessing ---
-#-Q- sxnec  prefix = -Wp,-D
-#-Q- sx6nec prefix = -Wp,-D
-#-Q- eshpux prefix = -Wp,-D
-#-Q- sxdkrz prefix = -Wp,-D
+#-Q- sxnec  prefix = -D
+#-Q- sx6nec prefix = -D
+#-Q- eshpux prefix = -D
+#-Q- sxdkrz prefix = -D
 #-Q- linux  prefix = -D
 #-Q- lxiv7  prefix = -D