Index: /trunk/NEMO/OPA_SRC/DOM/domhgr.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DOM/domhgr.F90	(revision 417)
+++ /trunk/NEMO/OPA_SRC/DOM/domhgr.F90	(revision 418)
@@ -110,6 +110,4 @@
          zlam1, zcos_alpha, zim1 , zjm1 , ze1, ze1deg,   &
          zphi1, zsin_alpha, zim05, zjm05
-         
-         real,dimension(:,:),pointer :: ffparent
       !!----------------------------------------------------------------------
 
Index: /trunk/NEMO/OPA_SRC/DOM/dommsk.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DOM/dommsk.F90	(revision 417)
+++ /trunk/NEMO/OPA_SRC/DOM/dommsk.F90	(revision 418)
@@ -501,5 +501,5 @@
       !!----------------------------------------------------------------------
       !! *Local declarations
-      INTEGER  :: ji, jj, jk, ii     ! dummy loop indices
+      INTEGER  :: ji, jj, jk, ii, jl ! dummy loop indices
       INTEGER ::   ine, inw, ins, inn, itest, ierror, iind, ijnd
       INTEGER, DIMENSION(jpi*jpj*jpk,3) ::  icoord
Index: /trunk/NEMO/OPA_SRC/DYN/dynvor.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DYN/dynvor.F90	(revision 417)
+++ /trunk/NEMO/OPA_SRC/DYN/dynvor.F90	(revision 418)
@@ -676,5 +676,5 @@
       !!----------------------------------------------------------------------
       !! * Local declarations
-      INTEGER ::   ioptio = 0      ! temporary integer
+      INTEGER ::   ioptio          ! temporary integer
 
       NAMELIST/nam_dynvor/ ln_dynvor_ens, ln_dynvor_ene, ln_dynvor_mix, ln_dynvor_een
@@ -700,4 +700,6 @@
       ENDIF
 
+      ioptio = 0
+
       IF( ln_dynvor_ens ) THEN
          IF(lwp) WRITE(numout,*)
Index: /trunk/NEMO/OPA_SRC/OBC/obcdta.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 417)
+++ /trunk/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 418)
@@ -84,17 +84,13 @@
       REAL(wp) ::   zxy
       !! * Ajouts FD
-      INTEGER ::  iyrel              ! number of years since 1992
       INTEGER ::  isrel              ! number of seconds since 1/1/1992
       INTEGER, SAVE ::  itobce, itobcw,  & ! number of time steps in OBC files
                         itobcs, itobcn     !    "       "       "       "
       INTEGER ::  ikprint        ! frequency for printouts.
-      INTEGER :: fid_e, fid_w, fid_n, fid_s, fid  ! file identifiers
+      INTEGER :: fid_e, fid_w, fid_n, fid_s       ! file identifiers
       LOGICAL :: l_exv
-      INTEGER, DIMENSION(flio_max_dims) ::    &
-            f_d  ,             & ! dimensions lenght
-            start,             & ! starting index read
-            count                ! number of indices to be read
+      INTEGER, DIMENSION(flio_max_dims) ::   f_d  ! dimensions lenght
      
-      CHARACTER(LEN=25) :: f_name,v_name
+      CHARACTER(LEN=25) :: v_name
       !!--------------------------------------------------------------------
 
@@ -1188,4 +1184,5 @@
       INTEGER, INTENT( in ) ::   kbt         ! barotropic ocean time-step index
       WRITE(*,*) 'obc_dta_bt: You should not have seen this print! error?', kt
+      WRITE(*,*) 'obc_dta_bt: You should not have seen this print! error?', kbt
    END SUBROUTINE obc_dta_bt
 #endif
@@ -1276,4 +1273,5 @@
      INTEGER, INTENT (in) :: kt, jn
      WRITE(*,*) 'obc_dta_bt: You should not have seen this print! error?', kt
+     WRITE(*,*) 'obc_dta_bt: You should not have seen this print! error?', jn
    END SUBROUTINE obc_dta_bt
 #endif
Index: /trunk/NEMO/OPA_SRC/TRA/tradmp.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 417)
+++ /trunk/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 418)
@@ -42,5 +42,6 @@
 
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &
-      strdmp        ! damping salinity trend (psu/s)
+      strdmp,              &  ! damping salinity trend (psu/s)
+      resto                   ! restoring coeff. on T and S (s-1)
 
    !! * Module variables
@@ -53,7 +54,4 @@
       bdmp   =  360.,      &  ! bottom time scale for internal damping (days)
       hdmp   =  800.          ! depth of transition between sdmp and bdmp (meters)
-
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-      resto         ! restoring coeff. on T and S (s-1)
 
    !! * Substitutions